#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int , int> pii;
typedef pair <ll , ll> pll;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

struct pt {
    ll x, y;
    pt(){}
    pt(ll x , ll y): x(x) , y(y) {}
    bool operator< (const pt & p) const {
        return x < p.x || x == p.x && y < p.y;
    }
};

bool operator==(pt a , pt b) {
    return a.x == b.x && a.y == b.y;
}

pt operator-(pt a , pt b) {
    return pt(a.x - b.x , a.y - b.y);
}

bool intersect_1d (ll a, ll b, ll c, ll d) {
    if (a > b) swap (a, b);
    if (c > d) swap (c, d);
    return max (a, c) <= min (b, d);
}
ll crossProduct(pt a , pt b) {
    return a.x*b.y - a.y*b.x;
}

ll dotProduct(pt a , pt b) {
    return a.x*b.x + a.y*b.y;
}

bool intersect_2d(pt a , pt b , pt c , pt d) {
    ll x = crossProduct(b - a , c - a);
    ll y = crossProduct(b - a , d - a);
    if (x >= 0 && y >= 0 || x <= 0 && y <= 0)
        return false;

    x = dotProduct(b - a , c - a);
    y = dotProduct(a - b , d - b);
    if (x >= 0 && y >= 0)
        return true;

    x = dotProduct(b - a , d - a);
    y = dotProduct(a - b , c - b);
    if (x >= 0 && y >= 0)
        return true;

    return false;
}

bool intersect (pt a, pt b, pt c, pt d) {
    if (!intersect_1d (a.x, b.x, c.x, d.x) || !intersect_1d (a.y, b.y, c.y, d.y))
        return false;
    if (a == c || a == d || b == c || b == d)
        return false;

    if (intersect_2d(a , b , c , d) || intersect_2d(b , a , c , d) || intersect_2d(c , d , a , b) || intersect_2d(c , d , b , a))
        return true;

    return false;
}

int n;
vector <pt> a;

int check() {
    set <pii> s;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            s.insert({i , j});
        }
    }
    int cnt = 0;
    while (!s.empty()) {
        pii cur = *s.begin();
        s.erase(s.begin());
        vector <pii> del;
        for (auto x : s) {
            if (intersect(a[cur.first] , a[cur.second] , a[x.first] , a[x.second])) {
                del.push_back(x);
            }
        }
        for (auto x : del) {
            s.erase(x);
        }
        cnt++;
    }
    return cnt%2;
}
int intf = 1e9;
pii ask(pii cur = {intf , intf}) {
    if (cur.first == intf) {
        cin >> cur.first >> cur.second;
        cur.first-- , cur.second--;
        return cur;
    } else {
        cur.first++ , cur.second++;
        cout << cur.first << ' ' << cur.second << endl;
    }
}

void solve(){
    cin >> n;
    a.resize(n);
    for (auto &x : a) {
        cin >> x.x >> x.y;
    }

    int type = check();
    if (type == 0)
        type = 2;

    cout << type << endl;
    set <pii> s;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            s.insert({i , j});
        }
    }
    type %= 2;

    while (true) {
        pii cur;
        if (type == 1) {
            cur = *s.begin();
            cout << cur.first + 1 << ' ' << cur.second + 1 << endl;
        } else {
            cin >> cur.first >> cur.second;
            cur.first-- , cur.second--;
        }
        if (cur.first < 0) {
            return;
        }
        type = (type + 1) % 2;
        s.erase(cur);
        vector <pii> del;
        for (auto x : s) {
            if (intersect(a[cur.first] , a[cur.second] , a[x.first] , a[x.second])) {
                del.push_back(x);
            }
        }
        for (auto x : del) {
            s.erase(x);
        }
    }
}
/*
3
0 0
10 0
0 10

4
0 0
10 0
5 7
5 3

 */
signed main() {
    //IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}