#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <bitset>
#include <queue>
#include <map>
#include <random>
#include <queue>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()
#define fi first
#define se second
#define pb emplace_back
#define ld long double

#define ALG
//#define MINT
//#define GEOM

#ifdef ALG
namespace alg_space
{
	template<class T>
	T sqr(T a)
	{
		return a * a;
	}

	template<class T>
	T gcd(T a, T b)
	{
		while (b != 0)
		{
			a %= b;
			swap(a, b);
		}
		return a;
	}
}

using namespace alg_space;
#endif

#ifdef MINT
namespace mint_space
{
#define FACT

#ifdef FACT
	const int MINT_N = 2e5;
#endif
	const int MINT_MOD = 1e9 + 7;

	struct mint
	{
		long long a;
		mint(int b) : a(b) {}
		mint(long long b) : a(b) {}
		mint() : a(0) {}
	};

	istream& operator>>(istream& cin, mint a)
	{
		return cin >> a.a;
	}

	ostream& operator<<(ostream& cout, const mint& a)
	{
		return cout << a.a;
	}

	mint operator+=(mint& a, mint b)
	{
		a.a += b.a;
		if (a.a > MINT_MOD)
		{
			a.a -= MINT_MOD;
		}
		return a;
	}

	mint operator+(mint a, mint b)
	{
		return a += b;
	}

	mint operator-=(mint& a, mint b)
	{
		a.a -= b.a;
		if (a.a < 0)
		{
			a.a += MINT_MOD;
		}
		return a;
	}

	mint operator-(mint a, mint b)
	{
		return a -= b;
	}

	mint operator*=(mint& a, mint b)
	{
		a.a *= b.a;
		a.a %= MINT_MOD;
		return a;
	}

	mint operator*(mint a, mint b)
	{
		return a *= b;
	}

	mint operator^(mint a, int b)
	{
		mint ans = 1;
		mint now = a;
		int i = 1;
		while (true)
		{
			if (i & b)
			{
				ans *= now;
			}
			if (i == (1 << 30))
			{
				break;
			}
			i <<= 1;
			now *= now;
		}
		return ans;
	}

	mint operator/=(mint& a, mint b)
	{
		a *= (b ^ (MINT_MOD - 2));
		return a;
	}

	mint operator/(mint a, mint b)
	{
		return a /= b;
	}

#ifdef FACT
	mint f[MINT_N];
	mint f1[MINT_N];

	void f_count(int n)
	{
		f[0] = 1;
		f1[0] = 1;
		for (int i = 1; i < n; i++)
		{
			f[i] = f[i - 1] * i;
			f1[i] = 1 / f[i];
		}
	}

	mint get_c(int n, int k)
	{
		return f[n] * f1[k] * f1[n - k];
	}

	mint get_a(int n, int k)
	{
		return f[n] * f1[n - k];
	}
#endif
}

using namespace mint_space;
#endif


const int N = 2e5 + 1337;

int t;
int n;
int good[N];
int bad[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> t;

	while(t-- > 0)
	{
		int n;
		cin >> n;
		for (int i = 0; i < n; i++)
		{
			cin >> bad[i];
		}

		int Max = 0;
		int id = 0;
		for (int i = 0; i < n; i++)
		{
			cin >> good[i];
			if (good[i] > Max)
			{
				id = i;
				Max = good[i];
			}
		}

		good[id] = 0;

		int nowGood = 0;
		int nowPairs = 0;
		int nowBad = 0;
		for (int i = 0; i < n; i++)
		{

			int newPairs1 = min(nowGood, bad[i]);
			bad[i] -= newPairs1;
			int newBad = min(nowPairs, bad[i]);
			bad[i] -= newBad;
			nowBad += newBad;

			int newPairs2 = min(good[i], nowBad);
			good[i] -= newPairs2;

			nowBad += bad[i];
			nowGood += good[i];
			nowPairs += newPairs1 + newPairs2;
		}

		if (nowGood > 0)
		{
			cout << "NO" << endl;
		}
		else
		{
			cout << "YES" << endl;
		}
	}
}