#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <bitset>
#include <queue>
#include <map>
#include <random>
#include <queue>

using namespace std;

#define ll long long
//#define endl '\n'
#define BE(v) v.begin(), v.end()
#define fi first
#define se second
#define pb emplace_back
#define ld long double

#define ALG
//#define MINT

#ifdef ALG
namespace alg_space
{
	template<class T>
	T sqr(T a)
	{
		return a * a;
	}

	template<class T>
	T gcd(T a, T b)
	{
		while (b != 0)
		{
			a %= b;
			swap(a, b);
		}
		return a;
	}
}

using namespace alg_space;
#endif

#ifdef MINT
namespace mint_space
{
#define FACT

#ifdef FACT
	const int MINT_N = 2e5;
#endif
	const int MINT_MOD = 1e9 + 7;

	struct mint
	{
		long long a;
		mint(int b) : a(b) {}
		mint(long long b) : a(b) {}
		mint() : a(0) {}
	};

	istream& operator>>(istream& cin, mint a)
	{
		return cin >> a.a;
	}

	ostream& operator<<(ostream& cout, const mint& a)
	{
		return cout << a.a;
	}

	mint operator+=(mint& a, mint b)
	{
		a.a += b.a;
		if (a.a > MINT_MOD)
		{
			a.a -= MINT_MOD;
		}
		return a;
	}

	mint operator+(mint a, mint b)
	{
		return a += b;
	}

	mint operator-=(mint& a, mint b)
	{
		a.a -= b.a;
		if (a.a < 0)
		{
			a.a += MINT_MOD;
		}
		return a;
	}

	mint operator-(mint a, mint b)
	{
		return a -= b;
	}

	mint operator*=(mint& a, mint b)
	{
		a.a *= b.a;
		a.a %= MINT_MOD;
		return a;
	}

	mint operator*(mint a, mint b)
	{
		return a *= b;
	}

	mint operator^(mint a, int b)
	{
		mint ans = 1;
		mint now = a;
		int i = 1;
		while (true)
		{
			if (i & b)
			{
				ans *= now;
			}
			if (i == (1 << 30))
			{
				break;
			}
			i <<= 1;
			now *= now;
		}
		return ans;
	}

	mint operator/=(mint& a, mint b)
	{
		a *= (b ^ (MINT_MOD - 2));
		return a;
	}

	mint operator/(mint a, mint b)
	{
		return a /= b;
	}

#ifdef FACT
	mint f[MINT_N];
	mint f1[MINT_N];

	void f_count(int n)
	{
		f[0] = 1;
		f1[0] = 1;
		for (int i = 1; i < n; i++)
		{
			f[i] = f[i - 1] * i;
			f1[i] = 1 / f[i];
		}
	}

	mint get_c(int n, int k)
	{
		return f[n] * f1[k] * f1[n - k];
	}

	mint get_a(int n, int k)
	{
		return f[n] * f1[n - k];
	}
#endif
}

using namespace mint_space;
#endif


const int N = 302;

template<typename Type>
struct Vec
{
	Type x, y;
	ld tg;

	Vec()
	{
		this->x = 0;
		this->y = 0;
	}

	Vec(Type x, Type y)
	{
		this->x = x;
		this->y = y;
	}

	friend istream& operator>>(istream& cin, Vec& v)
	{
		return cin >> v.x >> v.y;
	}

	friend ostream& operator<<(ostream& cout, Vec v)
	{
		return cout << v.x << ' ' << v.y << endl;
	}

	Vec& operator-= (Vec v)
	{
		x -= v.x;
		y -= v.y;
		return *this;
	}

	friend Vec operator-(Vec a, Vec b)
	{
		return a -= b;
	}

	Vec& operator+= (Vec v)
	{
		x += v.x;
		y += v.y;
		return *this;
	}

	friend Vec operator+(Vec a, Vec b)
	{
		return a += b;
	}

	Vec& operator*= (Type num)
	{
		x *= num;
		y *= num;
		return *this;
	}

	friend Vec operator*(Vec v, Type num)
	{
		return v *= num;
	}

	Vec& operator/= (Type num)
	{
		x /= num;
		y /= num;
		return *this;
	}

	friend Vec operator/(Vec v, Type num)
	{
		return v /= num;
	}

	friend Type operator*(Vec a, Vec b)
	{
		return a.x * b.x + a.y * b.y;
	}

	friend Type operator%(Vec a, Vec b)
	{
		return a.x * b.y - a.y * b.x;
	}

	void tan()
	{
		if (y == 0)
		{
			if (x == 0)
			{
				tg = 1e8;
			}
			else
			{
				tg = -1e8;
			}
		}
		else
		{
			tg = (ld)x / (ld)y;
		}
	}

	ll len()
	{
		return sqr(x) + sqr(y);
	}

	bool operator==(Vec v)
	{
		if (x == v.x && y == v.y)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
};

template<class T>
bool operator<(Vec<T> a, Vec<T> b)
{
	if (a.tg == b.tg)
	{
		return a.len() > b.len();
	}
	else
	{
		return a.tg > b.tg;
	}
}

Vec<int> v[N];
Vec<int> vold[N];

bool seg(int i1, int i2, int j1, int j2)
{
	if (i1 == j1 && i2 == j2)
	{
		return true;
	}
	if (i1 == j1 || i2 == j2 || i1 == j2 || i2 == j1)
	{
		return false;
	}
	if (((vold[i2] - vold[i1]) % (vold[j1] - vold[i1]) > 0) == ((vold[i2] - vold[i1]) % (vold[j2] - vold[i1]) > 0))
	{
		return false;
	}
	if (((vold[j2] - vold[j1]) % (vold[i1] - vold[j1]) > 0) == ((vold[j2] - vold[j1]) % (vold[i2] - vold[j1]) > 0))
	{
		return false;
	}
	return true;
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	Vec<int> bes(0, 1e5);
	vector<pair<int, int>> e;
	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			e.push_back({ i,j });
		}
	}
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
		vold[i] = v[i];
		if (v[i].y < bes.y)
		{
			bes = v[i];
		}
	}
	for (int i = 0; i < n; i++)
	{
		v[i] -= bes;
		v[i].tan();
	}
	sort(v, v + n);
	vector<Vec<int>> o;
	for (int i = 0; i < n; i++)
	{
		while (o.size() > 2)
		{
			if ((o[o.size() - 1] - o[o.size() - 2]) % (v[i] - o[o.size() - 1]) < 0)
			{
				o.pop_back();
			}
			else
			{
				break;
			}
		}
		o.push_back(v[i]);
	}
//#ifdef _DEBUG
//	cout << o.size();
//	return 0;
//#endif
	int cnt = o.size() * 2 - 3 + (n - o.size()) * 3;
	bool turn;
	if (cnt % 2)
	{
		cout << 1 << endl;
		turn = true;
	}
	else
	{
		cout << 2 << endl;
		turn = false;
	}
	vector<pair<int, int>> add;
	int i = 0;
	while (true)
	{
		if (turn)
		{
			for (i;; i++)
			{
				bool ok = true;
				for (int j = 0; j < add.size(); j++)
				{
					if (seg(e[i].first, e[i].second, add[j].first, add[j].second))
					{
						ok = false;
						break;
					}
				}
				if (ok)
				{
					add.push_back(e[i]);
					cout << e[i].first + 1 << " " << e[i].second + 1 << endl;
					break;
				}
			}
		}
		else
		{
			int a, b;
			cin >> a >> b;
			if (a == 0 && b == 0)
			{
				return 0;
			}
			add.push_back({ min(a - 1,b - 1),max(a - 1,b - 1) });
		}
		turn ^= 1;
	}
}