#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

struct node {
    int l, r;
    int sum;
    node *cl, *cr;
};

node* make_node(int l, int r) {
    node *root = new node;
    root->l = l;
    root->r = r;
    root->sum = 0;
    root->cl = nullptr;
    root->cr = nullptr;
    return root;
}

void push(node*& root) {
    int m = (root->l + root->r) / 2;
    if (root->cl == nullptr && root->l != root->r) {
        root->cl = make_node(root->l, m);
    }
    if (root->cr == nullptr && root->l != root->r) {
        root->cr = make_node(m + 1, root->r);
    }
}

void update(node *root, int pos) {
    push(root);
    if (pos < root->l || pos > root->r) {
        return;
    }
    if (root->l == pos && root->r == pos) {
        root->sum = 1;
        return;
    }
    update(root->cl, pos);
    update(root->cr, pos);
    root->sum = root->cl->sum + root->cr->sum;
}

int query(node *root, int l, int r) {
    push(root);
    if (root->sum == 0 || l > root->r || r < root->l) {
        return 0;
    }
    if (l <= root->l && root->r <= r) {
        return root->sum;
    }
    return query(root->cl, l, r) + query(root->cr, l, r);
}

void solve() {
    int n, m, s;
    cin >> n >> m >> s;
    node *root = make_node(0, 1e10);
    vector <int> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        update(root, a[i]);
    }
    sort(a.begin(), a.end());
    a.erase(unique(a.begin(), a.end()), a.end());
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        int prev = (i == 0 ? -1e10 : a[i - 1]);
        int l = prev, r = a[i];
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (query(root, mid, mid + m - 1) >= m - s) {
                r = mid;
            } else {
                l = mid;
            }
        }
        r = max(r, 1);
        r = min(r, n - m);
        if (r <= a[i] && (i == 0 || r > a[i - 1]) && query(root, r, r + m - 1) >= m - s) {
            ans += a[i] - r + 1;
        }
    }
    cout << ans << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
//     cin >> t;
    while (t--) solve();
}
