#ifndef ONPC
  #define _FORTIFY_SOURCE 0
  #pragma GCC optimize("Ofast")
  #pragma GCC optimize("no-stack-protector")
  #pragma GCC optimize("unroll-loops")
  #pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
  #pragma GCC optimize("fast-math")
#endif

#include <bits/stdc++.h>

#define mp make_pair
#define eb emplace_back
#define x first
#define y second

template <typename T>
bool chmax(T &a, const T &b) {
    if (a < b) {
      a = b;
        return true;
    }
    return false;
}

template <typename T>
bool chmin(T &a, const T &b) {
    if (a > b) {
      a = b;
      return true;
    }
    return false;
}

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pt;

#ifdef ONPC
mt19937 rnd(228);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 998244353LL;
const ld PI = acos(-1);

const int MAXN = 100;
//#define int long long
const int INF = 1e9;

ll kill(ll a, ll b){
  return min(a, b);
}

ll mrg(ll a1, ll b1, ll c1, ll a2, ll b2, ll c2, ll& a3, ll& b3, ll& c3){
  ll k1 = kill(a1, b2);
  ll k2 = kill(a2, b1);
  a1 -= k1;
  a2 -= k2;
  b2 -= k1;
  b1 -= k2;

  ll k3 = min(b1, kill(a1, c2));
  a1 -= k3;
  b1 -= k3;
  ll k4 = min(b2, kill(a2, c1));
  a2 -= k4;
  b2 -= k4;

  a3 = a1 + a2;
  b3 = b1 + b2;
  c3 = c1 + c2 + k1 + k2 + k3 + k4;
}

void solve(){
  int n;
  cin >> n;
  vector<ll> a(n), b(n);
  for (int i = 0; i < n; i++){
    cin >> a[i];
  }
  for (int i = 0; i < n; i++){
    cin >> b[i];
  }
  vector<pt> p(n + 1), s(n + 1);
  vector<ll> ps(n + 1, 0LL), ss(n + 1, 0LL);
  p[0] = {0LL, 0LL};
  s[n] = {0LL, 0LL};
  for (int i = 0; i < n; i++){
    mrg(p[i].x, p[i].y, ps[i], a[i], b[i], 0LL, p[i+1].x, p[i+1].y, ps[i+1]);
  }

  for (int i = n; i > 0; i--){
    mrg(s[i].x, s[i].y, ss[i], a[i-1], b[i-1], 0LL, s[i-1].x, s[i-1].y, ss[i-1]);
  }

  for (int i = 0; i < n; i++){
    ll a3, b3, c3;
    mrg(p[i].x, p[i].y, ps[i], s[i+1].x, s[i+1].y, ss[i+1], a3, b3, c3);
    if (b3 <= a[i]){
      cout << "YES\n";
      return;
    }
  }

  cout << "NO\n";
}

/*
#ifndef ONPC
#define FILEIO
#endif
*/
signed main()
{
    #ifdef FILEIO
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int Q;
    cin >> Q;
    while (Q--)
      solve();

    return 0;
}
