#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <climits>
#include <iomanip>
#include <iterator>
#include <cassert>

#ifndef LOCAL_BUILD
#pragma GCC optimize("-fcaller-saves,-fcrossjumping,-fthread-jumps,-funroll-loops,-fwhole-program,-freorder-blocks")
#pragma GCC optimize("-fpartial-inlining,-freorder-functions,-findirect-inlining,-fhoist-adjacent-loads,-ftree-vrp")
#pragma GCC optimize("-fsched-spec,-falign-jumps,-falign-loops,-falign-labels,-fdevirtualize,move-loop-invariants")
#pragma GCC optimize("-fschedule-insns,-fschedule-insns2,-fstrict-aliasing,-fdelete-null-pointer-checks,-fipa-sra")
#pragma GCC optimize("-fstrict-overflow,-falign-functions,-fcse-skip-blocks,-fcse-follow-jumps,-fsched-interblock")
#pragma GCC optimize("rename-registers,unr1oll-loops,inline-functions,inline-small-functions,vpt,function-sections")
#pragma GCC optimize("-frerun-cse-after-loop,-finline-small-functions,-ftree-switch-conversion,-ftree-tail-merge")
#pragma GCC optimize("-foptimize-sibling-calls,-fexpensive-optimizations,-funsafe-loop-optimizations,-ftree-pre")
#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
#pragma GCC optimize("inline-functions-called-once,tracer,profile-reorder-functions,unswitch-loops,-fgcse-lm")
#pragma GCC optimize("branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,-fpeephole2")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx2")
#pragma warning(disable : 4996)
#define _CRT_SECURE_NO_WARNINGS
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = 1e9 + 33;
ll GG = 1e15;
const ld PI = acosl(-1);

#define speed                         \
    ios_base::sync_with_stdio(false); \
    cin.tie(0);                       \
    cout.tie(0)

void solve();
signed main() {
    speed;
    solve();
}

int n, m, k;

void dfs(int u, vector<vector<int>>& graph, vector<int>& level) {
    for (int e : graph[u]) {
        if (level[e] == -1) {
            level[e] = (level[u] + 1) % k;
            dfs(e, graph, level);
        }
    }
}

void solve() {
    cin >> n >> m >> k;
    vector<int> old(n);
    for (int i = 0; i < n; i++)
        cin >> old[i];
    vector<vector<int>> graph(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a - 1].push_back(b - 1);
        graph[b - 1].push_back(a - 1);
    }
    vector<int> level(n, -1);
    dfs(0, graph, level);
    for (int e : level)
        cout << e + 1 << " ";
    cout << "\n";
}