#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int n, m, s;
    cin >> n >> m >> s;
    deque<int> d;
    vector<int> a(m);
    for (int i = 0; i < m; ++i) cin >> a[i];
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    int aSize = a.size();
    ll ans = 0;
    int l = 0, r = 0;
    int prev = 0;
    for (int i = 0; i < aSize; ++i) {
        while (r <= i) {
            d.push_back(a[r++]);
        }
        while (l < i) {
            d.pop_front();
            ++l;
        }
        while (r < aSize && a[r] <= a[l] + m - 1) {
            d.push_back(a[r]);
            ++r;
        }
        int left = 0, right = a[i] - prev + 1;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            int newRight = a[l] - mid + m;
            int cnt = upper_bound(all(d), newRight) - d.begin();
            if (cnt + s >= m) {
                left = mid;
            } else {
                right = mid;
            }
        }
        int newRight = a[l] - left + m;
        ans += max(0, min(n - newRight + 1, left));
        prev = a[i];
    }
    cout << ans;
}

int main() {
    START_TIME = clock();
    fast_in_out();
#ifdef __APPLE__
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << en << TIME * 1000 << " ms." << en;
#endif
    return 0;
}
