#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

struct Pt {
    int x;
    int y;

    Pt(int x_ = 0, int y_ = 0) : x(x_), y(y_) {}

    Pt operator+(Pt other) {
        return {x + other.x, y + other.y};
    }

    Pt operator-(Pt other) {
        return {x - other.x, y - other.y};
    }

    Pt operator*(Pt other) {
        return {x * other.x, y * other.y};
    }

    bool operator<(const Pt &other) const {
        return tie(y, x) < tie(other.y, other.x);
    }

    int dot(Pt other) {
        return x * other.x + y * other.y;
    }

    int cross(Pt other) {
        return x * other.y - y * other.x;
    }


};

struct Line {
    int a;
    int b;
    int c;

    Line(int a_, int b_, int c_) : a(a_), b(b_), c(c_) {}

    pair<double, double> intersection(Line other) {
        int d = Pt(a, b).cross(Pt(other.a, other.b));
        int dx = Pt(c, b).cross(Pt(other.c, other.b));
        int dy = Pt(a, c).cross(Pt(other.a, other.c));
        if (d == 0) {
            return {-1e9, -1e9};
        }
        return {-dx / (double) d, -dy / (double) d};
    }
};


Line get_straight(Pt self, Pt other) {
    int a = self.y - other.y;
    int b = other.x - self.x;
    int c = self.cross(other);
    return {a, b, c};
}

const int MAXN = 350;

bool used[MAXN][MAXN];

bool is_inter(Pt p1, Pt p2, Pt p3, Pt p4) {
    Line l1 = get_straight(p1, p2);
    Line l2 = get_straight(p3, p4);
    pair<double, double> kek = l1.intersection(l2);
    if (min(p1.x, p2.x) > kek.first || max(p1.x, p2.x) < kek.first) {
        return false;
    }
    if (min(p3.x, p4.x) > kek.first || max(p3.x, p4.x) < kek.first) {
        return false;
    }
    if (min(p1.y, p2.y) > kek.second || max(p1.y, p2.y) < kek.second) {
        return false;
    }
    if (min(p3.y, p4.y) > kek.second || max(p3.y, p4.y) < kek.second) {
        return false;
    }
    return true;
}

int check(vector<Pt> &a) {
    int n = a.size();
    int cnt = 0;
    while (true) {
        pair<int, int> res = {(int) -1e9, (int) -1e9};
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (!used[i][j]) {
                    res = {i, j};
                    break;
                }
            }
        }
        if (res.first == (int) -1e9) {
            break;
        }
        cnt++;
        Pt p1 = a[res.first], p2 = a[res.second];
        used[res.first][res.second] = true;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (i != res.first && j != res.second && !used[i][j] && i != res.second && j != res.first) {
                    if (is_inter(p1, p2, a[i], a[j])) {
                        used[i][j] = true;
                    }
                }
            }
        }
    }
    return (cnt % 2 == 1 ? 1 : 2);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<Pt> a(n);
    for (Pt &el : a) {
        cin >> el.x >> el.y;
    }
    int tar = check(a);
    cout << tar << endl;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            used[i][j] = false;
        }
    }
    if (tar == 2) {
        int r1, r2;
        cin >> r1 >> r2;
        r1--;
        r2--;
        if (r1 > r2) {
            swap(r1, r2);
        }
        used[r1][r2] = true;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (i != r1 && j != r2 && !used[i][j] && i != r2 && j != r1) {
                    if (is_inter(a[r1], a[r2], a[i], a[j])) {
                        used[i][j] = true;
                    }
                }
            }
        }
    }
    while (true) {
        pair<int, int> res = {(int) -1e9, (int) -1e9};
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (!used[i][j]) {
                    res = {i, j};
                    break;
                }
            }
        }
        Pt p1 = a[res.first], p2 = a[res.second];
        used[res.first][res.second] = true;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (i != res.first && j != res.second && !used[i][j] && i != res.second && j != res.first) {
                    if (is_inter(p1, p2, a[i], a[j])) {
                        used[i][j] = true;
                    }
                }
            }
        }
        cout << res.first + 1 << " " << res.second + 1 << endl;
        int r1, r2;
        cin >> r1 >> r2;
        if (r1 == 0 && r2 == 0) {
            break;
        }
        r1--;
        r2--;
        if (r1 > r2) {
            swap(r1, r2);
        }
        used[r1][r2] = true;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (i != r1 && j != r2 && !used[i][j] && i != r2 && j != r1) {
                    if (is_inter(a[r1], a[r2], a[i], a[j])) {
                        used[i][j] = true;
                    }
                }
            }
        }
    }
}