// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,unroll-all-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define ll long long
#define int ll
#define ld long double
#define pb push_back
#define pll pair<ll, ll>
#define ff first
#define ss second
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define mp make_pair

using namespace std;

const int p = 31;
const int mod = 1e9 + 7;
const int max_n = 2e3 + 5;
const int log_n = 20;
const int inf = 1e17;
const long double pi = acos(-1);
const ld eps = 1e-11;
const int len = 400;

std::mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

//-----------------------------------------------------------
// structs
struct Point {
    long double x, y;
    Point() {}
    Point(long double x, long double y) : x(x), y(y) {}
    void read() {
        cin >> x;
        cin >> y;
    }
    bool operator == (Point p) {
        return abs(x - p.x) <= eps && abs(y - p.y) <= eps;
    }
};
 
struct Vector {
    long double x, y;
    Point beg, end;
    Vector() {}
    Vector(Point beg, Point end) {
        this->x = end.x - beg.x;
        this->y = end.y - beg.y;
        this->beg = beg;
        this->end = end;
    }
    Vector(long double x, long double y) : x(x), y(y) {}
    Vector operator * (long double b) {
        return Vector(x * b, y * b);
    }
    Vector operator / (long double b) {
        return Vector(x / b, y / b);
    }
    Vector operator + (Vector a) {
        return Vector(x + a.x, y + a.y);
    }
};
 
struct Line {
    long double a, b, c;
    Point p1, p2;
    Line() {}
    Line(Point p1, Point p2) {
        a = p1.y - p2.y;
        b = p2.x - p1.x;
        c = -a * p1.x - b * p1.y;
        this->p1 = p1;
        this->p2 = p2;
    }
};
 
struct Segment {
    Point a, b;
    Segment() {}
    Segment(Point a, Point b) : a(a), b(b) {}
};
 
//-------------------------------------------------------------------------------------
// functions
 
long double vectorLength(Vector vec) {
    return sqrt(vec.x * vec.x + vec.y * vec.y);
}
 
long double dotProduct(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}
 
long double crossProduct(Vector a, Vector b) {
    return a.x * b.y - a.y * b.x;
}
 
long double pointDistance(Point a, Point b) {
    return sqrt((b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y));
}
 
bool isContained(Line line, Point a) {
    return ((line.a * a.x + line.b * a.y + line.c) <= eps);
}
 
bool isContained(Segment seg, Point p) {
    if (!isContained(Line(seg.a, seg.b), p))
        return false;
    if (dotProduct(Vector(seg.a, p), Vector(seg.a, seg.b)) >= 0 && dotProduct(Vector(seg.b, seg.a), Vector(seg.b, p)) >= 0)
        return true;
    else
        return false;
}
 
Point intersect(Line line1, Line line2) {
    long double a1 = line1.a, b1 = line1.b, c1 = line1.c;
    long double a2 = line2.a, b2 = line2.b, c2 = line2.c;
    if ((a1 * b2 - a2 * b1) == 0) return Point(-INT_MAX, -INT_MAX);
    Point p;
    p.x = (c2 * b1 - c1 * b2) / (a1 * b2 - a2 * b1);
    p.y = (a2 * c1 - a1 * c2) / (a1 * b2 - a2 * b1);
    return p;
}
 
bool isIntersect(Segment seg1, Segment seg2) {
    if (max(seg1.a.x, seg1.b.x) >= min(seg2.a.x, seg2.b.x) &&
        max(seg2.a.x, seg2.b.x) >= min(seg1.a.x, seg1.b.x) &&
        max(seg1.a.y, seg1.b.y) >= min(seg2.a.y, seg2.b.y) &&
        max(seg2.a.y, seg2.b.y) >= min(seg1.a.y, seg1.b.y)) {
        Vector v1 = Vector(seg1.a, seg2.a);
        Vector v2 = Vector(seg1.a, seg1.b);
        Vector v3 = Vector(seg1.a, seg2.b);
        Vector v4 = Vector(seg2.a, seg1.a);
        Vector v5 = Vector(seg2.a, seg2.b);
        Vector v6 = Vector(seg2.a, seg1.b);
        if (crossProduct(v2, v1) * crossProduct(v2, v3) <= 0 && crossProduct(v5, v4) * crossProduct(v5, v6) <= 0) {
            return true;
        }
    }
    return false;
}


void run() {
    int n;
    cin >> n;
    vector<Point> p(n);
    rep(i, n) {
        cin >> p[i].x >> p[i].y;
    }
    vector<Segment> cur;
    rep(i, n) {
        rep(j, i) {
            Segment s(p[i], p[j]);
            bool ok = 1;
            for (auto t : cur) {
                if (t.a == s.a || t.a == s.b || t.b == s.a || t.b == s.b) {
                    continue;
                }
                if (isIntersect(s, t)) {
                    ok = 0;
                    break;
                }
            }
            if (ok) cur.pb(s);
        }
    }
    int cnt = cur.size();
    int dur = 0;
    if (cnt % 2 != 0) {
        cout << 1 << endl;
        dur = 0;
    } else {
        cout << 2 << endl;
        dur = 1;
    }

    cur.clear();
    while (true) {
        if (dur) {
            int a, b;
            cin >> a >> b;
            if (a == 0 && b == 0) return;
            a--;
            b--;
            cur.pb(Segment(p[a], p[b]));
        } else {
            rep(i, n) {
                bool flag = 0;
                rep(j, i) {
                    Segment s(p[i], p[j]);
                    bool ok = 1;
                    for (auto t : cur) {
                        if ((t.a == s.a && t.b == s.b) || (t.a == s.b && t.b == s.a)) {
                            ok = 0;
                            break;
                        }
                        if (t.a == s.a || t.a == s.b || t.b == s.a || t.b == s.b) {
                            continue;
                        }
                        if (isIntersect(s, t)) {
                            ok = 0;
                            break;
                        }
                    }
                    if (ok) {
                        cout << i + 1 << ' ' << j + 1 << endl;
                        flag = 1;
                        cur.pb(s);
                        break;
                    }
                }
                if (flag) break;
            }
        }
        dur ^= 1;
    }
    
}

signed main() {
#ifndef ONLINE_JUDGE
    // files("input.txt", "output.txt");
#endif
    // files("optimize.in", "optimize.out");
    // srand(time(0));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        run();
    return 0;
}