#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector,btr-bb-exclusive,fast-math")

#include <bits/stdc++.h>

using namespace std;

#define int long long

vector< vector<int> > adj;
vector<bool> taken;
vector<bool> used;

char getchr(int i, int j) {
	return '0' + ((i * 3 + j) % 10);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<string> a(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector< vector<bool> > can_open(n, vector<bool>(m));
	vector< vector<int> > idof(n, vector<int>(m, -1));
	vector< vector<int> > opento(n, vector<int>(m, -1)); // 0 = right, clockwise
	int maxid = 0;
	for(int i = 0; i < n; i++) {
		for(int j = 0; j + 1 < m; j++) {
			if(a[i][j] == a[i][j + 1] && a[i][j] != '.') {
				if(a[i][j] >= 'A' && a[i][j] <= 'Z') {
					if(i + 1 < n && a[i + 1][j] == '.' && a[i + 1][j + 1] == '.') {
						can_open[i][j] = can_open[i][j + 1] = true;
						idof[i][j] = idof[i][j + 1] = maxid++;
						opento[i][j] = 1;
					}
				} else {
					if(i > 0 && a[i - 1][j] == '.' && a[i - 1][j + 1] == '.') {
						can_open[i][j] = can_open[i][j + 1] = true;
						idof[i][j] = idof[i][j + 1] = maxid++;
						opento[i][j] = 3;
					}
				}
			}
		}
	}
	for(int i = 0; i + 1 < n; i++) {
		for(int j = 0; j < m; j++) {
			if(a[i][j] == a[i + 1][j] && a[i][j] != '.') {
				if(a[i][j] >= 'A' && a[i][j] <= 'Z') {
					if(j + 1 < m && a[i][j + 1] == '.' && a[i + 1][j + 1] == '.') {
						can_open[i][j] = can_open[i + 1][j] = true;
						idof[i][j] = idof[i + 1][j] = maxid++;
						opento[i][j] = 0;
					}
				} else {
					if(j > 0 && a[i][j - 1] == '.' && a[i + 1][j - 1] == '.') {
						can_open[i][j] = can_open[i + 1][j] = true;
						idof[i][j] = idof[i + 1][j] = maxid++;
						opento[i][j] = 2;
					}
				}
			}
		}
	}

	adj.resize(maxid);
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			if(a[i][j] == '.') {
				vector<int> common;
				if(i > 0 && can_open[i - 1][j]) {
					common.push_back(idof[i - 1][j]);
				}
				if(j > 0 && can_open[i][j - 1]) {
					common.push_back(idof[i][j - 1]);
				}
				if(i + 1 < n && can_open[i + 1][j]) {
					common.push_back(idof[i + 1][j]);
				}
				if(j + 1 < m && can_open[i][j + 1]) {
					common.push_back(idof[i][j + 1]);
				}
				for(int x: common) {
					for(int y: common) {
						if(x != y) {
							adj[x].push_back(y);
						}
					}
				}
			}
		}
	}

	used.resize(maxid);
	taken.resize(maxid);
	for(int i = 0; i < maxid; i++) {
		if(!used[i]) {
			int u = i;
			int par = -1;
			bool found = false;
			do {
				found = false;
				for(int v: adj[u]) {
					if(v != par) {
						par = u;
						u = v;
						found = true;
						break;
					}
				}
			} while(found && u != i);

			bool do_take = true;
			do {
				if(do_take) {
					taken[u] = true;
				}
				used[u] = true;
				do_take = !do_take;
				found = false;
				for(int v: adj[u]) {
					if(!used[v]) {
						u = v;
						found = true;
						break;
					}
				}
			} while(found);
		}
	}

	int ans = 0;
	for(bool x: taken) {
		ans += x;
	}
	cout << ans << endl;

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			if(can_open[i][j] && taken[idof[i][j]]) {
				if(opento[i][j] == 0) {
					a[i][j] = a[i + 1][j] = a[i][j + 1] = a[i + 1][j + 1] = getchr(i, j);
				} else if(opento[i][j] == 1) {
					a[i][j] = a[i][j + 1] = a[i + 1][j] = a[i + 1][j + 1] = getchr(i, j);
				} else if(opento[i][j] == 2) {
					a[i][j] = a[i + 1][j] = a[i][j - 1] = a[i + 1][j - 1] = getchr(i, j - 1);
				} else if(opento[i][j] == 3) {
					a[i][j] = a[i][j + 1] = a[i - 1][j] = a[i - 1][j + 1] = getchr(i - 1, j);
				}
			} else if(a[i][j] != '.' && !('0' <= a[i][j] && a[i][j] <= '9')) {
				if(j + 1 < m && a[i][j] == a[i][j + 1]) {
					a[i][j] = a[i][j + 1] = getchr(i, j);
				} else if(i + 1 < n && a[i][j] == a[i + 1][j]) {
					a[i][j] = a[i + 1][j] = getchr(i, j);
				}
			}
		}
	}

	for(int i = 0; i < n; i++) {
		cout << a[i] << "\n";
	}

	return 0;
}