#include <bits/stdc++.h>

using namespace std;

//#pragma target("sse,sse2,sse3,ssse3,sse,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i : a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DOUT
        cout << x;
#endif
        return *this;
    }
} dout;

LogOutput fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

#define nl '\n'
#define elif else if
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v.size())
#define sqr(v) ((v) * (v))
#define vpi vector<pair<int, int>>
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % (m)) + (m))) % m)
#define vi vector<int>
#define pi pair<int, int>
#define ti tuple<int, int, int>
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max((x), (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double Pi = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cout.setf(ios::fixed);
    cout.precision(10);
}

const int N = 1010;

char field[N][N];

const int dx[] = {1, 0, -1, 0};
const int dy[] = {0, 1, 0, -1};

struct Pos {
    int x, y;
};

struct Sofa {
    Pos p1, p2;
    Pos vec;
    int id;
};

bool InField(int x, int y, int n, int m) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

vector<int> want[N][N];
int have[N][N];

vector<int> g[N * N];
bool ban[N * N];
bool used[N * N];
bool open[N * N];

int cntOpen = 0;

int ans[N][N];

void DFS(int v, bool f = true) {
    open[v] = f;
    cntOpen += f;
    used[v] = true;
    for (auto &to : g[v]) {
        if (used[to])
            continue;
        DFS(to, !f);
    }
}

int Mex(vi& v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
    forn(i, sz(v)) {
        if (v[i] != i)
            return i;
    }
    return sz(v);
}

void  F(int x, int y, int n, int m, vi& v) {
    forn(i, 4) {
        int nx = x + dx[i], ny = y + dy[i];
        if (InField(nx, ny, n, m)) {
            v.push_back(ans[nx][ny]);
        }
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    forn(i, n) {
        forn(j, m) {
            cin >> field[i][j];
            have[i][j] = -1;
        }
    }
    vector<Sofa> sofas;

    for (int x = 0; x < n; x++) {
        for (int y = 0; y < m; y++) {
            if (field[x][y] == '.')
                continue;
            char c = field[x][y];
            for (int k = 0; k < 2; k++) {
                int nx = x + dx[k], ny = y + dy[k];
                if (!InField(nx, ny, n, m) || field[nx][ny] != c)
                    continue;
                sofas.push_back({});
                Sofa &s = sofas.back();
                s.p1 = {x, y};
                s.p2 = {nx, ny};
                if (abs(x - nx) == 1 && 'a' <= c && c <= 'z')
                    s.vec = {0, -1};
                else if (abs(x - nx) == 1 && 'A' <= c && c <= 'Z')
                    s.vec = {0, 1};
                else if (abs(y - ny) == 1 && 'a' <= c && c <= 'z') {
                    s.vec = {-1, 0};
                } else if (abs(y - ny) == 1 && 'A' <= c && c <= 'Z') {
                    s.vec = {1, 0};
                }
                int id = sz(sofas) - 1;
                s.id = id;
                have[s.p1.x][s.p1.y] = id;
                have[s.p2.x][s.p2.y] = id;
//                want[s.p1.x + s.vec.x][s.p1.y + s.vec.y].push_back(id);
//                want[s.p2.x + s.vec.x][s.p2.y + s.vec.y].push_back(id);
            }
        }
    }
    for (auto &s : sofas) {
        int x1 = s.p1.x + s.vec.x, y1 = s.p1.y + s.vec.y;
        int x2 = s.p2.x + s.vec.x, y2 = s.p2.y + s.vec.y;
        if (!InField(x1, y1, n, m) || !InField(x2, y2, n, m) || have[x1][y1] != -1 || have[x2][y2] != -1) {
            ban[s.id] = true;
            continue;
        }
    }
    for (auto &s : sofas) {
        if (ban[s.id])
            continue;
        int x1 = s.p1.x + s.vec.x, y1 = s.p1.y + s.vec.y;
        int x2 = s.p2.x + s.vec.x, y2 = s.p2.y + s.vec.y;
        want[x1][y1].push_back(s.id);
        want[x2][y2].push_back(s.id);
    }
    forn(i, n) {
        forn(j, m) {
            for (int k = 0; k < sz(want[i][j]); k++) {
                int id1 = want[i][j][k];
                if (ban[id1])
                    continue;
                for (int f = k + 1; f < sz(want[i][j]); f++) {
                    int id2 = want[i][j][f];
                    if (ban[id2])
                        continue;
                    g[id1].push_back(id2);
                    g[id2].push_back(id1);
                }
            }
        }
    }
    sort(all(sofas), [&](const Sofa &a, const Sofa &b) {
        return sz(g[a.id]) < sz(g[b.id]);
    });
    for (auto &s : sofas) {
        if (used[s.id] || ban[s.id])
            continue;
        DFS(s.id);
    }

//    for (int i = 0; i < sz(sofas); i++) {
//        dout << "id: " << sofas[i].id << nl;
//        dout << i << ": ";
//        for (auto &to : g[i]) {
//            dout << to << " ";
//        }
//        dout << nl;
//    }
//    dout << nl << nl;
//    for (auto &s : sofas) {
//        dout << "id: " << s.id << nl;
//        dout << "vec: " << s.vec.x << " " << s.vec.y << nl;
//        dout << "p1: " << s.p1.x << " " << s.p1.y << nl;
//        dout << "p2: " << s.p2.x << " " << s.p2.y << nl;
//    }
//    dout << nl << nl << "ban:" << nl;
//    forn(i, sz(sofas)) {
//        dout << int(ban[i]) << ' ';
//    }
//    dout << nl;
    const int B = 1000000;
    forn(i, n) {
        forn(j, m) {
            ans[i][j] = B;
        }
    }
    for (auto& s : sofas) {
        ans[s.p1.x][s.p1.y] = B + s.id;
        ans[s.p2.x][s.p2.y] = B + s.id;
        if (open[s.id]) {
            int x1 = s.p1.x + s.vec.x, y1 = s.p1.y + s.vec.y;
            int x2 = s.p2.x + s.vec.x, y2 = s.p2.y + s.vec.y;
            ans[x1][y1] = B + s.id;
            ans[x2][y2] = B + s.id;
        }
    }
    for (auto& s : sofas) {
        vi v;
        F(s.p1.x, s.p1.y, n, m, v);
        F(s.p2.x, s.p2.y, n, m, v);
        if (open[s.id]) {
            int x1 = s.p1.x + s.vec.x, y1 = s.p1.y + s.vec.y;
            int x2 = s.p2.x + s.vec.x, y2 = s.p2.y + s.vec.y;
            F(x1, y1, n, m, v);
            F(x2, y2, n, m, v);
        }
        int a = Mex(v);
        ans[s.p1.x][s.p1.y] = a;
        ans[s.p2.x][s.p2.y] = a;
        if (open[s.id]) {
            int x1 = s.p1.x + s.vec.x, y1 = s.p1.y + s.vec.y;
            int x2 = s.p2.x + s.vec.x, y2 = s.p2.y + s.vec.y;
            ans[x1][y1] = a;
            ans[x2][y2] = a;
        }
    }
    cout << cntOpen << nl;
    forn(i, n) {
        forn(j, m) {
            cout << (ans[i][j] == B ? '.' : char(ans[i][j] + '0'));
        }
        cout << nl;
    }

}

signed main() {
    IO();
    int t = 1;
    // cin >> t;
    int startTime = clock();
    while (t--) {
        Solve();
    }
    int endTime = clock();
    dout << '\n' << "Time: " << (endTime - startTime + 999) / 1000;
    return 0;
}