#define _USE_MATH_DEFINES

#include <iostream>
#include <random>
#include <iomanip>
#include <functional>
#include <vector>
#include <set>
#include <map>
#include <cassert>
using namespace std;

#ifndef DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#endif

std::random_device rn;
std::mt19937 rng(rn());

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
int time_DEBUG;
#endif

void geom_out() {
    std::cout.setf(std::ios::fixed);
#ifdef DEBUG
    std::cout << std::setprecision(8);
#else
    std::cout << std::setprecision(35);
#endif
}

void fast_in_out() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void begin_ex() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    time_DEBUG = clock();
#endif
    fast_in_out();
    geom_out();
}

void end_ex() {
#ifdef DEBUG
    std::cerr << '\n' << static_cast<double>(clock() - time_DEBUG) / (CLOCKS_PER_SEC * 1.0) << " sec\n";
#endif
}

string get(int mask, int n) {
    string ret;
    for (int i = 0; i < n; i++) {
        int bit = (mask >> i) & 1;
        ret += char('0' + bit);
    }
    reverse(ret.begin(), ret.end());
    return ret;
}

int self(int a) {
    return a;
}

int sq(int a) {
    return a * a;
}

int p2n (int a){
    return 1 << a;
}

std::vector<int> gen_vec(int fst, int snd, int len, const std::function<int(int)>& f = self) {
    std::vector<int> res;
    res.reserve(len);
    if (len <= 0) return res;
    res.push_back(f(fst));
    if (len == 1) return res;
    res.push_back(f(snd));
    int a = 2 * snd - fst;
    for (int i = 2; i < len; ++i) {
        res.push_back(f(a));
        a += snd - fst;
    }
    return res;
}

std::vector<int> range(int fst, int last, int step = 1, const std::function<int(int)>& f = self) {
    std::vector<int> res;
    res.reserve((last - fst + step - 1) / step);
    for (int a = fst; f(a) < last; a += step) {
        res.push_back(f(a));
    }
    return res;
}

void solve() {
    ll n;
    cin >> n;
    auto pref = range(1, 21);
    ll sum = 0, ans = 0;
    for (int i = 0; i < n; ++i){
        sum += pref[i];
        if (sum >= n){
            ans = i;
            break;
        }
    }
    ll k = 1 << (ans);
    // cerr << k << endl;
    string s;
    for (ll i = 0; i < (1ll << n) / k; i++) {
        std::cout << get(i, k);
    }
    cout << '\n';
}

signed main() {
    begin_ex();

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    end_ex();
    return 0;
}