#define _USE_MATH_DEFINES

#include <iostream>
#include <random>
#include <iomanip>
#include <functional>
#include <vector>
#include <set>
#include <map>
using namespace std;

#ifndef DEBUG
//#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#endif

std::random_device rn;
std::mt19937 rng(rn());

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
int time_DEBUG;
#endif

void geom_out() {
    std::cout.setf(std::ios::fixed);
#ifdef DEBUG
    std::cout << std::setprecision(8);
#else
    std::cout << std::setprecision(35);
#endif
}

void fast_in_out() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void begin_ex() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    time_DEBUG = clock();
#endif
    fast_in_out();
    geom_out();
}

void end_ex() {
#ifdef DEBUG
    std::cerr << '\n' << static_cast<double>(clock() - time_DEBUG) / (CLOCKS_PER_SEC * 1.0) << " sec\n";
#endif
}

const int N = 40;
int C[N][N];
int n, k;
int ans = 0;

int getC(int x, int y) { return C[x + y - 1][y - 1]; }

void rec(int s, int prev, int cnt, int cur) {
    if (s > n) { return; }
    if (s == n) {
        cur *= getC(cnt, k);
        ans += cur;
    }
    if (prev != 0) rec(s + prev, prev, cnt + 1, cur);
    cur *= getC(cnt, k);
    for (int i = prev + 1; i <= N; i++) { rec(s + i, i, 1, cur); }
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i < N; i++) {
        C[i][0] = 1;
        for (int j = 1; j <= i; j++) { C[i][j] = C[i - 1][j] + C[i - 1][j - 1]; }
    }
    rec(0, 0, 0, 1);
    cout << ans << '\n';
}

signed main() {
    begin_ex();

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    end_ex();
    return 0;
}