#include<bits/stdc++.h>

using namespace std;

template <typename A, typename B>
string to_string(pair<A, B> p);

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p);

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p);

string to_string(const string& s) {
    return '"' + s + '"';
}

string to_string(const char& s) {
    string res = "'";
    res += s;
    res += "'";
    return res;
}

string to_string(bool b) {
    return (b ? "true" : "false");
}

string to_string(vector<bool> v) {
    string res = "{";
    for (int i = 0; i < static_cast<int>(v.size()); i++) {
        if (i) res += ", ";
        res += to_string(v[i]);
    }
    res += "}";
    return res;
}

template <size_t N>
string to_string(bitset<N> v) {
    string res = "";
    for (size_t i = 0; i < N; i++) {
        res += static_cast<char>('0' + v[i]);
    }
    return res;
}

template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ")";
}

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ", " + to_string(get<3>(p)) + ")";
}

void debug_out() { cerr << endl; }

template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define eb emplace_back
#define ld long double

void solve() {
    int n, W;
    cin >> n >> W;
    vector<int> w(n), cost(n);
    for (int i = 0; i < n; i++) cin >> w[i] >> cost[i];
    vector<int> b(n);
    iota(all(b), 0);
    sort(all(b), [&] (int x, int y) { return cost[x] * w[y] > cost[y] * w[x]; });
    vector<int> pref(n + 1, 0), C(n + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + w[b[i]];
        C[i + 1] = C[i] + cost[b[i]];
    }
    int ans = 0;
    int p = -1, d = -1;
    int MX = (3ll * W) / 2ll;
    for (int i = n - 1; i >= 0; i--) {
        if (pref[i + 1] <= (MX)) {
            ans = C[i + 1];
            p = i;
            break;
        }
    }
    int ans2 = 0, p2 = -1, d2 = -1;
    vector<int> c;
    vector<int> ind(n, -1);
    for (auto x : b) {
        if (w[x] <= W / 2) {
            c.pb(x);
            ind[x] = (int) c.size() - 1;
        }
    }
    vector<int> prefc(n + 1, 0), cc(n + 1, 0);
    for (int i = 0; i < c.size(); i++) {
        prefc[i + 1] = prefc[i] + w[c[i]];
        cc[i + 1] = cc[i] + cost[c[i]];
    }
    for (int i = 0; i < n; i++) {
        int j = b[i];
        if (MX < w[j]) continue;
        int l = 0, r = 0;
        if (ind[j] == -1) r = c.size() + 1;
        else r = ind[j] + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            int ww = w[j] + prefc[m];
            if (ww <= MX) {
                l = m;
            }
            else {
                r = m;
            }
        }
        int res = cost[j] + cc[l];
        if (res > ans2) {
            ans2 = res;
            p2 = l - 1;
            d2 = i;
        }
    }
    if (ans > ans2) {
        vector<int> A;
        for (int i = 0; i <= p; i++) A.pb(b[i]);
        sort(all(A));
        cout << A.size() << '\n';
        for (auto x : A) cout << x + 1 << " ";
        cout << '\n';
        return;
    }
    vector<int> A;
    for (int i = 0; i <= p2; i++) A.pb(c[i]);
    if (d2 != -1) A.pb(b[d2]);
    sort(all(A));
    cout << A.size() << '\n';
    for (auto x : A) cout << x + 1 << " ";
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
 }
