#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

const int N = 1e3 + 10, G = 5e5 + 10;
const int dx2[] = {0, 1, 0, -1}, dy2[] = {1, 0, -1, 0};
const int dx[] = {1, 0, 1, 0}, dy[] = {0, 1, 0, 1};

int n, m;
char a[N][N], ans[N][N];
int dd = 0;
int d[N][N];

struct Sofa {
	int x, y, d;
} sofas[G];
bool sbad[G];

vector<int> g[G];

bool ok(int i, int j) {
	return i >= 0 && j >= 0 && i < n && j < m;
}

array<pair<int, int>, 2> getopen(int sid) {
	array<pair<int, int>, 2> res;
	int cd = sofas[sid].d;
	res[0] = {sofas[sid].x + dx2[cd], sofas[sid].y + dy2[cd]};
	res[1] = {sofas[sid].x + dx2[cd] + dx[cd], sofas[sid].y + dy2[cd] + dy[cd]};
	return res;
}

char part[G];

void dfs_kl(int u, char cc = 0) {
	if (part[u] != -1) {
		assert(part[u] == cc);
		return;
	}
	part[u] = cc;
	for (int v : g[u]) {
		dfs_kl(v, char(1 - cc));
	}
}

vector<int> lef, rig;
int iter, used[G], match[G];

bool kuhn(int v) {
	if (used[v] == iter) {
		return false;
	}
	used[v] = iter;
	for (int u : g[v]) {
		if (match[u] == -1) {
			match[v] = u;
			match[u] = v;
			return true;
		}
	}
	for (int u : g[v]) {
		if (kuhn(match[u])) {
			match[v] = u;
			match[u] = v;
			return true;
		}
	}
	return false;
}

vector<int> t[G];
bool opened[G];

void dfs(int v) {
	opened[v] = true;
	for (int u : t[v]) {
		if (!opened[u]) {
			dfs(u);
		}
	}
}

void matching() {
	for (int i = 0; i < dd; ++i) {
		if (part[i]) {
			lef.push_back(i);
		} else {
			rig.push_back(i);
		}
	}
	iter = 1;
	fill_n(match, G, -1);
	for (bool run = true; run; ++iter) {
		run = false;
		for (int v : lef) {
			if (match[v] == -1 && kuhn(v)) {
				run = true;
			}
		}
	}
	for (int v : lef) {
		for (int u : g[v]) {
			if (match[v] == u) {
				t[u].push_back(v);
			} else {
				t[v].push_back(u);
			}
		}
	}
	for (int v : lef) {
		if (match[v] == -1) {
			dfs(v);
		}
	}
	for (int v : rig) {
		opened[v] ^= 1;
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	fill(d[0], d[N], -1);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i][j] != '.') {
				if (ok(i + 1, j) && a[i][j] == a[i + 1][j]) {
					d[i][j] = dd;
					sofas[dd++] = {i, j, 0 + 2 * int(a[i][j] >= 'a')};
				} else if (ok(i, j + 1) && a[i][j] == a[i][j + 1]) {
					d[i][j] = dd;
					sofas[dd++] = {i, j, 1 + 2 * int(a[i][j] >= 'a')};
				}
			}
		}
	}
	for (int i = 0; i < dd; ++i) {
		auto r = getopen(i);
		for (auto c : r) {
			if (a[c.x][c.y] != '.') {
				sbad[i] = true;
				break;
			}
		}
		// if (sbad[i])
		// 	cout << sofas[i].x << " " << sofas[i].y << endl;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (d[i][j] == -1 || sbad[d[i][j]])
				continue;
			for (int cx = -4; cx <= 4; ++cx) {
				for (int cy = -4; cy <= 4; ++cy) {
					if (!cx || !cy)
						continue;
					if (!ok(i + cx, j + cy))
						continue;
					if (d[i + cx][j + cy] == -1)
						continue;
					auto r1 = getopen(d[i][j]);
					auto r2 = getopen(d[i + cx][j + cy]);
					bool flag = 0;
					for (auto c1 : r1) {
						for (auto c2 : r2) {
							if (c1 == c2)
								flag = 1;
						}
					}
					if (flag) {
						// cout << "adding" << endl;
						g[d[i][j]].push_back(d[i + cx][j + cy]);
					}
				}
			}
		}
	}
	// cout << "edge begin" << endl;
	// for (int u = 0; u < dd; ++u)
	// 	for (int v : g[u])
	// 		cout << u << "-> " << v << endl;
	// cout << "edge "
	fill(all(part), -1);
	for (int i = 0; i < dd; ++i) {
		if (part[i] == -1) {
			dfs_kl(i, 0);
		}
		// cout << part[i] << " ";
	}
	matching();
	// for (int i = 0; i < dd; ++i)
	// 	cout << opened[i] << " ";
	// cout << endl;
	int lans = 0;
	fill(ans[0], ans[N], '.');
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (d[i][j] == -1)
				continue;
			int sid = d[i][j];
			if (opened[sid] && !sbad[sid])
				lans += 1;
			vector<pair<int, int>> curr;
			curr.push_back({i, j});
			curr.push_back({i + dx[sofas[sid].d], j + dy[sofas[sid].d]});
			if (opened[sid] && !sbad[sid]) {
				auto res = getopen(sid);
				curr.insert(end(curr), all(res));
			}
			for (auto c : curr) {
				assert(ans[c.x][c.y] == '.');
				ans[c.x][c.y] = 'x';
			}
			set<int> mex;
			for (auto c : curr) {
				for (int d = 0; d < 4; ++d) {
					int nx = c.x + dx2[d], ny = c.y + dy2[d];
					if (ok(nx, ny) && ans[nx][ny] != 'x' && ans[nx][ny] != '.')
						mex.insert(ans[nx][ny] - '0');
				}
			}
			int color = -1;
			for (int cc = 0; cc < 10; ++cc) {
				if (!mex.count(cc)) {
					color = cc;
					break;
				}
			}
			assert(color != -1);
			for (auto c : curr) {
				ans[c.x][c.y] = color + '0';
			}
		}
	}
	cout << lans << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cout << ans[i][j];
		cout << "\n";
	}
	return 0;
}