//bs:console,-input
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

// #define GEOM_USE_FLOATS

namespace Geometry {

typedef ld float_t;

#ifdef GEOM_USE_FLOATS
typedef float_t coord_t;
#else
typedef ll coord_t;
#endif // GEOM_USE_FLOATS

const coord_t INF = 1e18;
const float_t EPS = 1e-10, PI = 3.141592653598979;

struct Point;
typedef Point Vector;
struct Line;
struct Polygon;
typedef Polygon PointsSet;

inline int cmp(coord_t a, coord_t b) {
#ifdef GEOM_USE_FLOATS
	if (abs(a - b) < EPS)
		return 0;
#else
	if (a == b)
		return 0;
#endif
	if (a < b)
		return -1;
	return 1;
}

struct Point {
	coord_t x, y;

	Point();
	Point(coord_t, coord_t);

	bool in(Polygon& p) const;
	bool inConvexPolygon(const Polygon& p) const; // counterclockwise

	float_t length() const;

#ifdef GEOM_USE_FLOATS
	void normalize();
	Point normalized() const;
#endif // GEOM_USE_FLOATS
};

struct Line {
	coord_t a, b, c;

	Line();
	Line(coord_t, coord_t, coord_t);
	Line(const Point&, const Point&);
};

struct Polygon {
	vector<Point> points;

	Polygon();
	Polygon(const int&);

	int size() const;

	float_t getPerimeter() const;
	coord_t getDoubleArea() const;
	float_t getArea() const;

	void toConvexPolygon();

	vector<pair<Point, int>> getSortedDirections() const;
	int getTangentByDirection(const vector<pair<Point, int>>&, const Vector&) const;
	pair<int, int> getTangentFromPoint(const Point&) const;

	Point& operator[](int i);	
};

float_t dist(const Point&, const Point&);
coord_t distSq(const Point&, const Point&);

vector<int> getConvexHull(int, const Point*);

Point intersect(const Line&, const Line&);

Point operator+(const Point&, const Vector&);
void operator+=(Point&, const Vector&);
Vector operator+(const Vector&, const Vector&);
Vector operator-(const Vector&);
Vector operator-(const Point&, const Point&);
Vector operator*(const Vector&, coord_t);
coord_t operator*(const Vector&, const Vector&); // dot product
coord_t operator%(const Vector&, const Vector&); // cross product

// IO operations
istream& operator>>(istream& in, Point& p) {
	return in >> p.x >> p.y;
}

istream& operator>>(istream& in, Line& l) {
	in >> l.a >> l.b >> l.c;
	l.c = -l.c;
	return in;
}

istream& operator>>(istream& in, Polygon& p) {
	for (int i = 0; i < int(p.points.size()); ++i)
		in >> p.points[i];
	return in;
}

ostream& operator<<(ostream& out, const Point& p) {
	return out << "(" << p.x << ", " << p.y << ")";
}

ostream& operator<<(ostream& out, const Line& p) {
	return out << "Line(" << p.a << ", " << p.b << ", " << p.c << ")";
}

// Point implementation
Point::Point() : x(0), y(0) {}

Point::Point(coord_t x_, coord_t y_) : x(x_), y(y_) {}

bool Point::in(Polygon& p) const {
	p.points.push_back(p.points[0]);
	int intersections = 0;
	for (int i = 0; i < p.size() - 1; ++i) {
		Point c = p.points[i] - *this, d = p.points[i + 1] - *this;
		if (c.y > d.y)
			swap(c, d);
		if (cmp((c - d) % (-d), 0) == 0 && cmp((-c) % (d - c), 0) == 0 &&
			cmp((c - d) * (-d), 0) >= 0 && cmp((-c) * (d - c), 0) >= 0)
			return true;
		if (cmp(c.y, d.y) != 0 && cmp(c.y, 0) <= 0 && cmp(d.y, 0) > 0)
			if (cmp((-d) % (c - d), 0) > 0 && cmp((-c) % (d - c), 0) < 0)
				++intersections;
	}
	p.points.pop_back();
	return intersections & 1;
}

bool Point::inConvexPolygon(const Polygon& p) const {
	Vector pV = *this - p.points[0];
	if (cmp((p.points[1] - p.points[0]) % pV, 0) < 0 || cmp(pV % (p.points[p.size() - 1] - p.points[0]), 0) < 0)
		return false;
	int left = 1, right = p.size() - 1;
	while (right - left > 1) {
		int mid = (left + right) / 2;
		if (cmp(pV % (p.points[mid] - p.points[0]), 0) <= 0)
			left = mid;
		else
			right = mid;
	}
	return cmp((*this - p.points[left]) % (p.points[0] - p.points[left]), 0) >= 0 &&
		   cmp((p.points[right] - p.points[left]) % (*this - p.points[left]), 0) >= 0;
}

float_t Point::length() const {
	return hypot(x, y);
}

#ifdef GEOM_USE_FLOATS
void Point::normalize() {
	float_t len = length();
	x /= len, y /= len;
}

Vector Point::normalized() const {
	float_t len = length();
	return {x / len, y / len};
}
#endif // GEOM_USE_FLOATS

// Line implementation
Line::Line() {
	a = 0, b = 0, c = 0;
}

Line::Line(coord_t a_, coord_t b_, coord_t c_) {
	a = a_, b = b_, c = c_;
}

Line::Line(const Point& p1, const Point& p2) {
	a = p2.y - p1.y, b = p1.x - p2.x;
	c = a * p1.x + b * p1.y;
}

// Polygon implementation
Polygon::Polygon() {
	points.resize(0);
}

Polygon::Polygon(const int& n) {
	points.resize(n);
}

int Polygon::size() const {
	return sz(points);
}

float_t Polygon::getPerimeter() const {
	float_t res = dist(points[size() - 1], points[0]);
	for (int i = 1; i < size(); ++i) {
		res += dist(points[i - 1], points[i]);
	}
	return res;
}

coord_t Polygon::getDoubleArea() const {
	coord_t area = 0;
	for (int i = 2; i < size(); ++i)
		area += (points[i] - points[0]) % (points[i - 1] - points[0]);
	return area;
}

float_t Polygon::getArea() const {
	return getDoubleArea() / 2.0L;
}

void Polygon::toConvexPolygon() {
	vector<int> ch = getConvexHull(size(), &points[0]);
	vector<Point> res;
	res.reserve(ch.size());
	for (int u : ch)
		res.push_back(points[u]);
	points = res;
}

bool __atan2LikeLess(const Point& a, const Point& b) {
	int asq = 1, bsq = 1;
	if (cmp(a.y, 0) < 0 || (cmp(a.y, 0) == 0 && cmp(a.x, 0) < 0))
		asq = 0;
	if (cmp(b.y, 0) < 0 || (cmp(b.y, 0) == 0 && cmp(b.x, 0) < 0))
		bsq = 0;
	if (asq != bsq)
		return asq < bsq;
	return cmp(a % b, 0) > 0;
}

int __atan2LikeCmp(const Point& a, const Point& b) {
	if (__atan2LikeLess(a, b))
		return -1;
	if (cmp(a % b, 0) == 0 && cmp(a * b, 0) >= 0)
		return 0;
	return 1;
}

bool __gsdCmp(const pair<Point, int>& a, const pair<Point, int>& b) {
	return __atan2LikeLess(a.first, b.first);
}

vector<pair<Point, int>> Polygon::getSortedDirections() const {
	vector<pair<Point, int>> res;
	res.resize(size());
	for (int i = 0; i < size() - 1; ++i)
		res[i] = {points[i + 1] - points[i], i};
	res.back() = {points[0] - points.back(), size() - 1};
	stable_sort(res.begin(), res.end(), &__gsdCmp);
	return res;
}

int Polygon::getTangentByDirection(const vector<pair<Point, int>>& sd, const Vector& v) const {
	if (__atan2LikeLess(v, sd[0].first))
		return sd[0].second;
	if (__atan2LikeLess(sd.back().first, v))
		return sd[0].second;
	int l = -1, r = sz(sd) - 1;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		if (__atan2LikeCmp(v, sd[mid].first) == 1)
			l = mid;
		else
			r = mid;
	}
	return sd[r].second;
}

pair<int, int> Polygon::getTangentFromPoint(const Point &p) const {
	if (points.size() == 1)
		return {0, -1};
	if (points.size() == 2) {
		if ((p - points[0]) * (points[0] - points[1]) > 0)
			return {0, 0};
		else
			return {1, 1};
	}
	
	return {-1, -1};
}

// Distances
float_t dist(const Point& a, const Point& b) {
	return hypot(a.x - b.x, a.y - b.y);
}

coord_t distSq(const Point& a, const Point& b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

// Functions
bool __chCmp(const pair<Point, int>& a, const pair<Point, int>& b) {
	coord_t res = a.first % b.first;
	return cmp(res, 0) > 0 || (cmp(res, 0) == 0 && cmp(distSq(a.first, Point(0, 0)), distSq(b.first, Point(0, 0))) == -1);
}

vector<int> getConvexHull(int n, const Point* inPoints) {
	if (n == 1)
		return {0};
	vector<pair<Point, int>> points;
	vector<int> ans;
	int index = 0;
	for (int i = 1; i < n; ++i)
		if (cmp(inPoints[index].x, inPoints[i].x) == 1 ||
			(cmp(inPoints[index].x, inPoints[i].x) == 0 && cmp(inPoints[index].y, inPoints[i].y) == 1))
			index = i;
	Point center = inPoints[index];

	for (int i = 0; i < n; ++i)
		if (index != i)
			points.push_back({inPoints[i] - center, i});
	stable_sort(points.begin(), points.end(), &__chCmp);
	for (int i = 0; i < sz(points); ++i)
		points[i].first += center;
	
	ans.push_back(index);
	ans.push_back(points[0].second);
	for (int i = 1; i < sz(points); ++i) {
		while (ans.size() > 1 &&
			   cmp((inPoints[ans[ans.size() - 1]] - inPoints[ans[ans.size() - 2]]) %
			   (points[i].first - inPoints[ans[ans.size() - 1]]), 0) <= 0)
			ans.pop_back();
		ans.push_back(points[i].second);
	}
	return ans;
}

Point intersect(const Line& l1, const Line& l2) {
	if (cmp(l1.a * l2.b - l2.a * l1.b, 0) == 0)
		return Point(+INF, +INF);
	return Point((l1.c * l2.b - l2.c * l1.b) / (l1.a * l2.b - l2.a * l1.b), (l1.c * l2.a - l2.c * l1.a) / (l1.b * l2.a - l2.b * l1.a));
}

// Operators
Point& Polygon::operator[](int i) {
	return points[i];
}

Point operator+(const Point& a, const Vector& b) {
	return {a.x + b.x, a.y + b.y};
}

void operator+=(Point& a, const Vector& b) {
	a.x += b.x, a.y += b.y;
}

Vector operator-(const Vector& a) {
	return {-a.x, -a.y};
}

Vector operator-(const Point& a, const Point& b) {
	return {a.x - b.x, a.y - b.y};
}

Vector operator*(const Vector& a, coord_t k) {
	return {a.x * k, a.y * k};
}

coord_t operator*(const Vector& a, const Vector& b) {
	return a.x * b.x + a.y * b.y;
}

coord_t operator%(const Vector& a, const Vector& b) {
	return a.x * b.y - a.y * b.x;
}
} // namespace Geometry
using namespace Geometry;

const int N = 302;

int turn(Point a, Point b, Point c) {
	ll x = (b - a) % (c - a);
	if (x < 0) {
		return -1;
	} else if (x == 0) {
		return 0;
	} else {
		return +1;
	}
}

bool sub(Point a, Point b, Point c, Point d) {
	return turn(a, b, c) * turn(a, b, d) < 0;
}

bool intersect(const Point &a, const Point &b, const Point &c, const Point &d) {
	return sub(a, b, c, d) && sub(c, d, a, b);
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	Polygon p(n);
	cin >> p;
	vector<int> ch = getConvexHull(n, &p.points[0]);
	int cnt = sz(ch) + (sz(ch) - 3) + 3 * (n - sz(ch));
	int turn = 1;
	if (cnt % 2) {
		turn = 0;
	}
	cout << turn + 1 << endl;
	vector<pair<int, int>> pos;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j)
			pos.push_back({i, j});
	}
	for (int i = 0; i < cnt; ++i) {
		int u, v;
		if (!turn) {
			tie(u, v) = pos[0];
			cout << pos[0].x + 1 << " " << pos[0].y + 1 << endl;
		} else {
			cin >> u >> v;
			if (u == 0 && v == 0)
				return 0;
			--u, --v;
			if (u > v)
				swap(u, v);
		}
		vector<pair<int, int>> npos;
		for (auto c : pos) {
			if (c == make_pair(u, v) || intersect(p[u], p[v], p[c.x], p[c.y]))
				continue;
			npos.push_back(c);
		}
		pos = npos;
		turn = 1 - turn;
	}
	assert(sz(pos) == 0);
	return 0;
}