#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <bitset>
#include <fstream>

using namespace std;
using ll = long long;

ll const inf = 1e18;

ifstream fin("input.txt");
ofstream fout("output.txt");

signed main()
{
	ll t; cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector<ll> a(n), b(n);
		ll sa = 0, sb = 0;
		for (ll i = 0; i < n; ++i)
		{
			cin >> a[i];
			sa += a[i];
		}

		int k = 0;
		int m = 0;

		for (ll i = 0; i < n; ++i)
		{
			cin >> b[i];
			sb += b[i];
			if (b[k] < b[i])
			{
				k = i;
			}
			else if (b[k] == b[i] && a[k] < a[i])
			{
				k = i;
			}
		}

		vector<ll> sums(n); // sum  " min(c[j] - b[i], a[j]) " for all j
		vector<ll> c(n); // c[j] == sb - b[j]
		for (int i = 0; i < n; ++i)
			c[i] = sb - b[i];

		vector<pair<ll, ll>> pb(n); // sorts pairs <b[i], i>
		for (int i = 0; i < n; ++i)
		{
			pb[i] = { b[i], i };
		}
		sort(pb.begin(), pb.end());

		vector<pair<ll, ll>> r(n); // is sorts <c[j] - a[j], j>
		for (int i = 0; i < n; ++i)
			r[i] = { c[i] - a[i], i };
		sort(r.begin(), r.end());

		int i1 = 0, i2 = 0; // with pb and r 
		while (i2 < n && r[i2].first <= 0)
			++i2;

		for (int j = 0; j < n; ++j)
		{
			sums[pb[i1].second] += min(sb - b[pb[i1].second] - b[j], a[j]);
		}
		i1++;
		while (i1 < n)
		{
			sums[pb[i1].second] = sums[pb[i1 - 1].second];
			sums[pb[i1].second] += i2 * (pb[i1 - 1].first - pb[i1].first);
			while (i2 < n && r[i2].first <= pb[i1].first)
			{
				sums[pb[i1].second] += c[r[i2].second] - pb[i1].first - a[r[i2].second];
				++i2;
			}
			i1++;
		}

/*		vector<ll> ans(n, 0);
		for (ll i = 0; i < n; ++i)
		{
			ll ans = sb - b[i];
			for (int j = 0; j < n; ++j)
			{
				ans -= min(sb - b[i] - b[j], a[j]);
			}
		}
*/
		ll mans = inf;

		for (ll i = 0; i < n; ++i)
		{
			ll ans = sb - b[i];
			ans -= min(sb - b[i], a[i]);
			ans -= sums[i];
			ans += min(sb - b[i] - b[i], a[i]);
			mans = min(mans, ans);
		}

		if (mans >= 1)
			cout << "NO\n";
		else
			cout << "YES\n";
		
	}
	cin >> t;



	return 0;
}