#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <bitset>
#include <fstream>

using namespace std;
using ll = long long;

ll const inf = 1e18;

ifstream fin("input.txt");
ofstream fout("output.txt");

ll n, k, x = 0;

ll bin_pow(ll a, ll n)
{
	if (a == 0) return 1; //

	ll res = 1;
	while (n > 0)
	{
		if (n % 2 == 1)
			res *= a;
		a *= a;
		n /= 2;
	}
	return res;
}


signed main()
{
	cin >> n >> k;

	vector<vector<ll>> dp1(n + 1, vector<ll>(k + 1, 0));

	for (int j = 0; j < k + 1; ++j)
		dp1[0][j] = 1;

	for (int i = 1; i < n + 1; ++i)
		for (int j = 0; j < k + 1; ++j)
		{
			if (j > 0)
				dp1[i][j] = dp1[i - 1][j] + dp1[i][j - 1];
			else
				dp1[i][j] = dp1[i - 1][j];
		}

	vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, 0));
	dp[0][0] = 1;

	for (int i = 0; i < n + 1; ++i)
		for (int j = 0; j < n; ++j)
		{
			for (int t = 0; i + (j + 1) * t <= n; ++t)
			{
				dp[i + (j + 1)* t][j + 1] += dp[i][j] * dp1[t][k - 1];
			}
		}

	cout << dp[n][n];
	cin >> n;


	return 0;
}