#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
using namespace std;

int n, m;
struct cell{
    int divan_num;
    map<int, pair<int, int>> edges;
};
const int MAXN = 1000;

cell f[MAXN][MAXN];
char chf[MAXN][MAXN];

bool type(int i, int j){
    return 'a' <= chf[i][j] && chf[i][j] <= 'z';
}

int look(int i, int j){
    if(chf[i][j] == -1){
        return -1;
    }
    if(i + 1 < n && chf[i + 1][j] == chf[i][j]){
        if(type(i, j)){
            return 3;
        } 
        return 1;
    } else {
        if(type(i, j)){
            return 0;
        } 
        return 2;
    }
}

bool is_cycle(int i, int j){
    if(i && j && i + 2 < n && j + 2 < m){
        return chf[i - 1][j] == chf[i - 1][j + 1] && chf[i][j + 2] == chf[i + 1][j + 2] && 
        chf[i + 2][j] == chf[i + 2][j + 1] && chf[i][j - 1] == chf[i + 1][j - 1] &&
        look(i - 1, j) == 2 && look(i, j - 1) == 1 && look(i + 2, j) == 0 && look(i, j + 2) == 3;    
    }
    return false;
}

int main() {
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            f[i][j].divan_num = -1;
        }
    }
    int divan_cnt = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> chf[i][j];
        }
    }
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(chf[i][j] != '.' && f[i][j].divan_num == -1){
                f[i][j].divan_num = divan_cnt;
                if(i + 1 < n && chf[i + 1][j] == chf[i][j]){
                    f[i + 1][j].divan_num = divan_cnt;
                    if('a' <= chf[i][j] && chf[i][j] <= 'z'){
                        if(j){
                            f[i][j - 1].edges[divan_cnt] = {i + 1, j - 1};
                            f[i + 1][j - 1].edges[divan_cnt] = {i, j - 1};
                        }
                    } else {
                        if(j + 1 < m){
                            f[i][j + 1].edges[divan_cnt] = {i + 1, j + 1};
                            f[i + 1][j + 1].edges[divan_cnt] = {i, j + 1};
                        }
                    }
                } else {
                    f[i][j + 1].divan_num = divan_cnt;
                    if('a' <= chf[i][j] && chf[i][j] <= 'z'){
                        if(i){
                            f[i - 1][j].edges[divan_cnt] = {i - 1, j + 1};
                            f[i - 1][j + 1].edges[divan_cnt] = {i - 1, j};
                        }
                    } else {
                        if(i + 1 < n){
                            f[i + 1][j].edges[divan_cnt] = {i + 1, j + 1};
                            f[i + 1][j + 1].edges[divan_cnt] = {i + 1, j};
                        }
                    }
                }
                divan_cnt++;
            } 
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(f[i][j].divan_num == -1){
                if(f[i][j].edges.size()){
                    if(is_cycle(i, j)){
                        ans += 2;
                        f[i][j + 1].divan_num = f[i][j].divan_num = f[i - 1][j].divan_num;
                        f[i + 1][j].divan_num = f[i + 1][j + 1].divan_num = f[i + 2][j].divan_num;
                    } else {
                        if(f[i][j].edges.size() != 2){
                            pair<int, int> prev = {i, j};
                            int i_ = i, j_ = j;
                            int a = 0;
                            while(f[i_][j_].edges.size()){
                                int i__ = f[i_][j_].edges.begin()->second.first;
                                int j__ = f[i_][j_].edges.begin()->second.second;                            
                                if(a % 2 == 0){
                                    f[i_][j_].divan_num = f[i__][j__].divan_num = f[i_][j_].edges.begin()->first;
                                    ans++;
                                }
                                f[i__][j__].edges.erase(f[i_][j_].divan_num);
                                f[i_][j_].edges.erase(f[i_][j_].divan_num);
                                a++;
                            }
                        }
                    }
                }
            }
        }
    }
    cout << ans << '\n';
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(f[i][j].divan_num == -1){
                cout << "."; 
            } else {
                cout << f[i][j].divan_num % 10;
            }
        }
        cout << '\n';
    }
}